#ifndef __USB_CONNECT_H
#define __USB_CONNECT_H 1

typedef unsigned long dword;
typedef unsigned short word;
typedef unsigned char byte;

class TResponce;

struct TInquiryData
{
    byte DeviceType : 5;
    byte DeviceTypeQualifier : 3;
    byte DeviceTypeModifier : 7;
    byte RemovableMedia : 1;
    byte Versions;
    byte ResponseDataFormat : 4;
    byte HiSupport : 1;
    byte NormACA : 1;
    byte ReservedBit : 1;
    byte AERC : 1;
    byte AdditionalLength;
    byte Reserved[2];
    byte SoftReset : 1;
    byte CommandQueue : 1;
    byte Reserved2 : 1;
    byte LinkedCommands : 1;
    byte Synchronous : 1;
    byte Wide16Bit : 1;
    byte Wide32Bit : 1;
    byte RelativeAddressing : 1;
    byte VendorId[8];
    byte ProductId[16];
    byte ProductRevisionLevel[4];
};

class DSC
{
   void* handle;

public:

   DSC(void* _handle = (void*)(-1)) { handle = _handle; }
  ~DSC();

   bool Okay() const { return handle != (void*)(-1); }
   void* GetHandle() const { return handle; }

   bool Read_CCD_DEFECT_Table();
   void ReadCameraInfo();

   bool SetReg(int reg, unsigned value);
   bool SetStr(int reg, const char* str);

   bool GetReg(int reg, unsigned& value);
   bool GetVar(int reg, TResponce&);

   bool SpecCmd(int reg, unsigned value, unsigned timeout=0);

   bool usbSendAck();
   bool usbSpecCmd(int reg, int value);
   bool usbSendCmdSetReg(int reg, unsigned value);
   bool usbStartIO();
   bool usbSendCmd(int type, int reg);
   bool usbSendCmdSetStr(int reg, const char*);
   bool usbAcceptResponce(void* buf, int size);
   bool usbGetAck();
   bool usbGetSize(unsigned& size);

};

void* OpenDSC(char camera_drive = ' ');
bool GetDeviceName(void*, TInquiryData&);
bool CloseCamera(void*);

struct TResponceVar
{
   dword length;
   word code; // 1,2,3
   word code2; // 0,0x9FFF
   dword _unknown[14]; // for sizeof == 64

   word cmd; // 3,2
   word len; //
   byte data[1];
};

class TResponce
{
public:
   ~TResponce() { free(); }
   TResponce() { ptr=0; size=0; }

   bool alloc(unsigned sz) { free(); return 0 != (ptr = (TResponceVar*)new byte[size=sz]); }
   void free() { delete [] ptr; ptr=0; size=0; }

   TResponceVar* ptr;
   unsigned size;

   const char* GetStr() const { return (const char*)ptr->data; }
};

#endif//#ifndef __USB_CONNECT_H 
